// This script demonstrates the coordinate motion (CM2) in the
// Maze Pennyhedron puzzle (before the maze is added!)

// Piece A, as exported from BurrTools
// (DeDoeDakKaVariants.xmpuzzle)
mypiece = "MazePennyhedronAOffset05.stl";

// BurrTools export params
unitSize = 10.0;
bevel = 0.30;
offset = 0.10;
// Everything else 0 or off

// a and b are the basic parameters which describe how the
// puzzle comes apart.

// When a=b=0, the puzzle is assembled.
// When a>0 and b=0, the puzzle comes apart via the PMV's:
PMVa = [[+1,+1,+1], [-1,-1,+1], [-1,+1,-1], [+1,-1,-1]];

// When b>0 and a=0, the puzzle comes apart via the PMV's:
PMVb = [[+1,+1,-1], [-1,-1,-1], [-1,+1,+1], [+1,-1,+1]];

// When a==b>0, the puzzle comes apart via P4:
//     [[+1,+1, 0], [-1,-1, 0], [-1,+1, 0], [+1,-1, 0]];

// When a>0 and b>0, the puzzle comes apart via both PMVs!

a = 0.0;
b = 8.0;

translate(v=a*PMVa[0]+b*PMVb[0])
  color("red") mypieceA();
  
translate(v=a*PMVa[1]+b*PMVb[1])
  rotate(a=[0,0,180])
  color("yellow") mypieceA();

translate(v=a*PMVa[2]+b*PMVb[2])
  color("blue") mypieceM();
  
translate(v=a*PMVa[3]+b*PMVb[3])
  rotate(a=[0,0,180])
  color("green") mypieceM();
    

// Piece A moved to the proper position
module mypieceA() {
  rotate(a=[0,0,-45])
  rotate(a=-120,v=[0,sqrt(2.),-1])
  rotate(a=[0,0,45])
  translate(v=[-4.*unitSize,-4.*unitSize,-4.*unitSize])
    import(mypiece, convexity = 4);
}

// Piece M moved to the proper position
module mypieceM() {
  rotate(a=[0,0,90])
  mirror(v=[0,0,1])
  mypieceA();
}

