// This script demonstrates the coordinate motion (CM+) in
// Hole In One Base

// Hole In One Base, as exported from BurrTools
// (HoleInOneVariants.xmpuzzle)
myfile0 = "HIOBase.stl";

// BurrTools export params
unitSize = 20.0;
bevel = 0.00;
offset = 0.05;

theta = atan(sqrt(2.));

// Piece colors: red, lime, blue
// Axis of puzzle goes [-1,1,-1] -> [1,-1,1] (before rotations)

a = 0.; // blue up, green down
b = 0.; // green up, red down
c = 5.; // red up, blue down
mysum = a+b+c;

frac = 0.5*(1+sqrt(2.));
c120 = cos(120); // -1/2
s120 = sin(120); // sqrt(3)/2

PMVa = [[1,0,0*frac], [c120,s120,-frac], [c120,-s120,frac]];
PMVb = [[1,0,-frac], [c120,s120,frac], [c120,-s120,0*frac]];
PMVc = [[1,0,frac], [c120,s120,0*frac], [c120,-s120,-frac]];

translate(v=a*PMVa[0]+b*PMVb[0]+c*PMVc[0])
  color("red") mypiece0();

translate(v=a*PMVa[1]+b*PMVb[1]+c*PMVc[1])
  rotate(a=[0,0,120])
  color("lime") mypiece0();

translate(v=a*PMVa[2]+b*PMVb[2]+c*PMVc[2])
  rotate(a=[0,0,-120])
  color("blue") mypiece0();

module mypiece0() {
  rotate(a=[0,-theta,30])
  rotate(a=[0,0,45])
  translate(v=[-2.*unitSize,-2.*unitSize,-2.*unitSize])
    import(myfile0, convexity = 4);
}
