// This script demonstrates the coordinate motion (CM1) in
// Iwahiros's Apparently Impossible Cube

// The two pieces, as exported from BurrTools
myfile0 = "AICp0.stl";
myfile1 = "AICp1.stl";

// BurrTools export params
unitSize = 20.0;

// a is the basic parameters which describes how the
// puzzle comes apart.

// When a=0, the puzzle is assembled.
// When a>0, the puzzle comes apart via the PMV's:
PMVa = [[-1,0,0], [+1,0,0], [0,0,+1], [0,0,-1]];

a = 15.;

translate(v=a*PMVa[0])
color("red") mypiece0();

translate(v=a*PMVa[1])
color("lime") rotate(a=[0,180,0]) mypiece0();

translate(v=a*PMVa[2])
color("aqua") mypiece1();

translate(v=a*PMVa[3])
color("yellow") rotate(a=[0,180,0]) mypiece1();

// Piece0 moved to the proper position
module mypiece0() {
translate(v=[-2.*unitSize,-2.*unitSize,0.*unitSize])
  import(myfile0, convexity = 4);
}

// Piece1 moved and rotated to the proper position
module mypiece1() {
rotate(a=[180,-90,0])
  translate(v=[-2.*unitSize,-2.*unitSize,0.*unitSize])
  import(myfile1, convexity = 4);
}
